---
title: Demos
keywords: simulation
tags: [jpscore, test]
sidebar: jupedsim_sidebar
folder: jpscore
permalink: jpscore_demos.html
summary: Introduction of demos in jpscore.

last_updated: Feb 06, 2020
---

## 01_corridor
**Description**

This demo shows 20 agents moving from left to right in a rectangular corridor.

The length of the corridor is 10 meters and the width is 2 meters.

**Settings**
- Model: [Generalized Centrifugal Force Model](jpscore_operativ.html#generalized-centrifugal-force-model)
- Router: [Global shortest path](jpscore_routing.html#global-shortest-path)
- Strategy: [Strategy 2](jpscore_direction.html#strategy-2)

![demo 01 corridor]({{ site.baseurl }}/images/demo_01_corridor.png)

## 02_bottleneck
**Description**

This demo shows 30 agents passing through a bottleneck from left to right.

The width of the bottleneck is 1.2 meters.

**Settings**
- Model: [Collision-free Speed Model](jpscore_operativ.html#collision-free-speed-model)
- Router: [Global shortest path](jpscore_routing.html#global-shortest-path)
- Strategy: [Strategy 3](jpscore_direction.html#strategy-3)

![demo 02 bottleneck]({{ site.baseurl }}/images/demo_02_bottleneck.png)

## 03_corner
**Description**

This demo shows 30 agents moving from a rectangular room into a rectangular corridor, then through a corner into another rectangular corridor.

The two corridors are perpendicular to each other.

The width of the first corridor and the second corridors are both 2 meters.

**Settings**
- Model: [Generalized Centrifugal Force Model](jpscore_operativ.html#generalized-centrifugal-force-model)
- Router: [Global shortest path](jpscore_routing.html#global-shortest-path)
- Strategy: [Strategy 2](jpscore_direction.html#strategy-2)

![demo 03 corner]({{ site.baseurl }}/images/demo_03_corner.png)

## 04_stairs
**Description**

This demo shows 7 agents moving from one room to another higher room through stairs.

The height difference between the two rooms is 6 meters.

The width of the stairs is 1 meter.

**Settings**
- Model: [Generalized Centrifugal Force Model](jpscore_operativ.html#generalized-centrifugal-force-model)
- Router: [Floorfield Router](jpscore_routing.html#floorfield-router)
- Strategy: [Strategy 8](jpscore_direction.html#strategy-8)

![demo 04 stairs]({{ site.baseurl }}/images/demo_04_stairs.png)

## 05_events
**Description**

This demo shows an agent evacuating from a building consisting of 7 rooms and a T-shaped corridor.

The status of doors in the building can be open or close, and are controlled by the event defined in the file *events_list.xml*.

**Settings**
- Model: [Generalized Centrifugal Force Model](jpscore_operativ.html#generalized-centrifugal-force-model)
- Router: [Global shortest path](jpscore_routing.html#global-shortest-path)
- Strategy: [Strategy 2](jpscore_direction.html#strategy-2)

![demo 05 events]({{ site.baseurl }}/images/demo_05_events.png)

## 06_floorfield
**Description**

This demo shows 100 agents evacuating from a building consisting of 13 rooms, a long corridor and four exits.


**Settings**
- Model: [Collision-free Speed Model](jpscore_operativ.html#collision-free-speed-model)
- Router: [Floorfield Router](jpscore_routing.html#floorfield-router)
- Strategy: [Strategy 8](jpscore_direction.html#strategy-8)

![demo 06 floorfield]({{ site.baseurl }}/images/demo_06_floorfield.png)

## 07_big_room
**Description**

This demo shows 250 agents evacuating from a big room with four exits.

**Settings**
- Model: [Collision-free Speed Model](jpscore_operativ.html#collision-free-speed-model)
- Router: [Floorfield Router](jpscore_routing.html#floorfield-router)
- Strategy: [Strategy 3](jpscore_direction.html#strategy-3)

![demo 07 big room]({{ site.baseurl }}/images/demo_07_big_room.png)

## 08_sources
**Description**

The demo shows five group of agents first being generated by sources at the four corners and the mid of a rectangular room, then evacuating from the room. 

**Settings**
- Model: [Collision-free Speed Model](jpscore_operativ.html#collision-free-speed-model)
- Router: [Global shortest path](jpscore_routing.html#global-shortest-path)
- Strategy: [Strategy 2](jpscore_direction.html#strategy-2)

![demo 08 sources]({{ site.baseurl }}/images/demo_08_sources.png)

## 09_area
**Description**

The demo shows the using of waiting area.

**Settings**
- Model: [Collision-free Speed Model](jpscore_operativ.html#collision-free-speed-model)
- Router: [Floorfield Router](jpscore_routing.html#floorfield-router)
- Strategy: [Strategy 8](jpscore_direction.html#strategy-8)

![demo 09 area]({{ site.baseurl }}/images/demo_09_area.png)

## 10_schedule
**Description**

The demo shows the using of schedule.

**Settings**
- Model: [Collision-free Speed Model](jpscore_operativ.html#collision-free-speed-model)
- Router: [Floorfield Router](jpscore_routing.html#floorfield-router)
- Strategy: [Strategy 8](jpscore_direction.html#strategy-8)

![demo 10 schedule]({{ site.baseurl }}/images/demo_10_schedule.png)